//+------------------------------------------------------------------+ 
//|   MACD_STOC  derived from Damon_MACD                                                     | 
//|                                                                  | 
//+------------------------------------------------------------------+ 
//
//  Fixed logic in original code in type 1 buy and sell.
//  Added Stochastic evaluation 
//  Changed output from color to shapes
//  Changed output from buy/sell signals to simple main versus signal for direction  and then add specific triggers to buy and sell 
//  by www.forex-tools-cafe.com 
//

#property indicator_chart_window

extern bool Show_Heading = true;

 
extern string IndNameMAC = "MACD:" ; // change
extern string IndNameSTO = "STOC:" ;

extern bool Corner_of_Chart_RIGHT_TOP = false;

extern int Shift_UP_DN = 0; 
extern int Adjust_Side_to_side  = 68; // 20

extern color BarLabel_color = MidnightBlue;
extern color CommentLabel_color = MidnightBlue;
extern color UpArrowColor=Green;
extern color DnArrowColor=FireBrick; 

// STOCH is 10,6 ,6 

extern int FastEMA      = 21;
extern int SlowEMA      = 55;
extern int SignalSMA    = 8;
extern int K           = 8;
extern int Slow         = 5;
extern int D           = 3;
extern int AppliedPrice = PRICE_CLOSE;

//extern int MAMethod=0;
//extern int PriceField=0; 

extern double Level5 =  95 ;
extern double Level4 =  75 ;
extern double Level3 =  50 ;
extern double Level2 =  25 ;
extern double Level1 =  5 ;
extern double Level0 =  0 ;

extern color Buy1_color  = Lime;
extern color Buy2_color  = Green;
extern color Buy3_color  = SeaGreen;
extern color Wait_color  = Yellow;
extern color Sell1_color = Red;
extern color Sell2_color = Crimson;
extern color Sell3_color = OrangeRed;

//******************* 

//*******************

string ObjHead01,ObjHead02,ObjHead03,ObjHead04,ObjHead05,ObjHead06,ObjHead07,ObjHead08,ObjHead09,ObjHead10,ObjHead11;  

string Obj0001,Obj0002,Obj0003,Obj0004,Obj0005,Obj0006,Obj0007,Obj0008,Obj0009,Obj0010,Obj0011;  
string Obj0001S,Obj0002S,Obj0003S,Obj0004S,Obj0005S,Obj0006S,Obj0007S,Obj0008S,Obj0009S,Obj0010S,Obj0011S; 
int    MAMode;
string strMAType;
 
double Stoch ;
double Open0, Open1, Open2, Close0, Close1, Close2, High0, High1, High2, Low0,  Low1, Low2, Range0, Range1, Range2, AvgRng3 ;
		
color MA_color;

int  lastExtreme = 0;

int       MACD_strength, STOC_strength; 
    

int init()
{
   

   return(0);
}
 

int start()
{    

   // string LabelTime="";

   // if (LabelTime=="") {LabelTime=TimeToStr(TimeLocal(),TIME_SECONDS); }

    int    counted_bars=IndicatorCounted();


    ObjHead01 = "DamonColHead01"   ;  
    ObjHead02 = "DamonColHead02"  ;  
    ObjHead03 = "DamonColHead03"  ; 
    ObjHead04 = "DamonColHead04"   ;  
    ObjHead05 = "DamonColHead05"  ;  
    ObjHead06 = "DamonColHead06"   ; 
    ObjHead07 = "DamonColHead07"   ;  
    ObjHead08 = "DamonColHead08"   ;  
    ObjHead09 = "DamonColHead09"   ; 
     
    string Damon_ObjHead01 ="M1 " ;
    string Damon_ObjHead02 ="M5  " ;     
    string Damon_ObjHead03 ="M15 " ;
    string Damon_ObjHead04 =" M30 " ;
    string Damon_ObjHead05 ="H1  " ;     
    string Damon_ObjHead06 ="H4  " ;
    string Damon_ObjHead07 ="D1  " ;
    string Damon_ObjHead08 ="W1  " ;
    string Damon_ObjHead09 ="MN1" ;   


    
    if (Corner_of_Chart_RIGHT_TOP == true)
    { 
        int Col01x = 170+Adjust_Side_to_side  ;                 
        int Col01y = Shift_UP_DN ;
    }
    else
    { 
        Col01x = Adjust_Side_to_side+ 159 ;       
        Col01y = Shift_UP_DN ;
    } 

    int ColAdj = -26 ;   // was 20
    int Col02x = Col01x + ColAdj ;   
    int Col03x = Col01x + ColAdj*2 ; 
    int Col04x = Col01x + ColAdj*3 ; 
    int Col05x = Col01x + ColAdj*4 ; 
    int Col06x = Col01x + ColAdj*5 ; 
    int Col07x = Col01x + ColAdj*6 ;    
    int Col08x = Col01x + ColAdj*7 ; 
    int Col09x = Col01x + ColAdj*8 ;     

    if ( Show_Heading) 
    {        
        ObjectCreate(ObjHead01, OBJ_LABEL, 0, 0, 0);
        ObjectSetText(ObjHead01,Damon_ObjHead01 , 9, "Tahoma", BarLabel_color);
        ObjectSet(ObjHead01, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
        ObjectSet(ObjHead01, OBJPROP_XDISTANCE, Col01x -5 );
        ObjectSet(ObjHead01, OBJPROP_YDISTANCE, Col01y); 

  /*      ObjectCreate(ObjHead02, OBJ_LABEL, 0, 0, 0);
        ObjectSetText(ObjHead02, "" , 9, "Tahoma", BarLabel_color);
        ObjectSet(ObjHead02, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
        ObjectSet(ObjHead02, OBJPROP_XDISTANCE, Col02x);
        ObjectSet(ObjHead02, OBJPROP_YDISTANCE, Col01y);   
  */ 
        ObjectCreate(ObjHead03, OBJ_LABEL, 0, 0, 0);
        ObjectSetText(ObjHead03,Damon_ObjHead03 , 9, "Tahoma", BarLabel_color);
        ObjectSet(ObjHead03, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
        ObjectSet(ObjHead03, OBJPROP_XDISTANCE, Col03x -5 );
        ObjectSet(ObjHead03, OBJPROP_YDISTANCE, Col01y); 
/*
        ObjectCreate(ObjHead04, OBJ_LABEL, 0, 0, 0);
        ObjectSetText(ObjHead04,"" , 9, "Tahoma Narrow", BarLabel_color);
        ObjectSet(ObjHead04, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
        ObjectSet(ObjHead04, OBJPROP_XDISTANCE, Col04x);
        ObjectSet(ObjHead04, OBJPROP_YDISTANCE, Col01y); 
*/
        ObjectCreate(ObjHead05, OBJ_LABEL, 0, 0, 0);
        ObjectSetText(ObjHead05,Damon_ObjHead05 , 9, "Tahoma Narrow", BarLabel_color);
        ObjectSet(ObjHead05, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
        ObjectSet(ObjHead05, OBJPROP_XDISTANCE, Col05x -5 );
        ObjectSet(ObjHead05, OBJPROP_YDISTANCE, Col01y); 
 /*       
        ObjectCreate(ObjHead06, OBJ_LABEL, 0, 0, 0);
        ObjectSetText(ObjHead06,"" , 9, "Tahoma Narrow", BarLabel_color);
        ObjectSet(ObjHead06, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
        ObjectSet(ObjHead06, OBJPROP_XDISTANCE, Col06x);
        ObjectSet(ObjHead06, OBJPROP_YDISTANCE, Col01y); 
*/
        ObjectCreate(ObjHead07, OBJ_LABEL, 0, 0, 0);
        ObjectSetText(ObjHead07,Damon_ObjHead07 , 9, "Tahoma Narrow", BarLabel_color);
        ObjectSet(ObjHead07, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
        ObjectSet(ObjHead07, OBJPROP_XDISTANCE, Col07x -5 );
        ObjectSet(ObjHead07, OBJPROP_YDISTANCE, Col01y); 
/*     
        ObjectCreate(ObjHead08, OBJ_LABEL, 0, 0, 0);
        ObjectSetText(ObjHead08,"" , 9, "Tahoma Narrow", BarLabel_color);
        ObjectSet(ObjHead08, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
        ObjectSet(ObjHead08, OBJPROP_XDISTANCE, Col08x);
        ObjectSet(ObjHead08, OBJPROP_YDISTANCE, Col01y); 
*/
        ObjectCreate(ObjHead09, OBJ_LABEL, 0, 0, 0);
        ObjectSetText(ObjHead09,Damon_ObjHead09 , 9, "Tahoma Narrow", BarLabel_color);
        ObjectSet(ObjHead09, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
        ObjectSet(ObjHead09, OBJPROP_XDISTANCE, Col09x -5 );
        ObjectSet(ObjHead09, OBJPROP_YDISTANCE, Col01y); 
   
    } // Show_Heading

 
    
    string M1_Damon= "-",M5_Damon= "-", M15_Damon= "-", M30_Damon= "-", H1_Damon= "-", H4_Damon= "-", D1_Damon= "-", W1_Damon= "-", MN1_Damon= "-";
    string M1_SDamon= "-",M5_SDamon= "-", M15_SDamon= "-", M30_SDamon= "-", H1_SDamon= "-", H4_SDamon= "-", D1_SDamon= "-", W1_SDamon= "-", MN1_SDamon= "-";

    int  strength_Damonm1,strength_Damonm5,strength_Damonm15,strength_Damonm30;
    int  strength_DamonH1,strength_DamonH4,strength_DamonD1,strength_DamonW1,strength_DamonMN1;     
      
      // found by hunt and peck, Does not agree with the published Wingdings font 
        //   ''  right arrow
        //   'K'  neutral face
        //   'a'  gemini Symbol
        //   '...' hollow 5 in a circle
        //   '' up arrow
        //   '' down arrow
        //     checkmark 
        
        //     arrow pointing northwest  (nice square arrow)
        //     arrow pointing southwest
        //     arrow pointing northeast
        //     arrow to southeast
        //     double arrow up and down 
        //     double arrow left and right
        //     small square 
        //     down arrow 
        //     up arrow 
        //     arrow to right 
        //     arrow to left 
        
        //     thick arrow to south east
        //     thick arrow to north east
        //     thick arrow to northwest 
        //     thick arrow down 
        //     thick arrow up 
        //     star in circle 
        //      three point star
        //   s    white diamond
        //   
   //Damon Signals

    string Flat =         "s";
    string Up=            ""  ; //"^";
    string Dn=            "";
    string ArrowHeadUp =  ""; //"" ; //  
    string ArrowHeadDn =  "" ; //   


    string symbol = Symbol() ;

    StrengthDamon( symbol, PERIOD_M1  ) ;
        if ( MACD_strength == 0 )       M1_Damon=Flat;
        else if ( MACD_strength == 1 )  M1_Damon=Up; 
        else if ( MACD_strength == 2 )  M1_Damon=ArrowHeadUp;
        else if ( MACD_strength == -1 ) M1_Damon=Dn;
        else if ( MACD_strength == -2 ) M1_Damon=ArrowHeadDn;
        
        if ( STOC_strength == 0 )       M1_SDamon=Flat;
        else if ( STOC_strength == 1 )  M1_SDamon=Up; 
        else if ( STOC_strength == 2 )  M1_SDamon=ArrowHeadUp;
        else if ( STOC_strength == -1 ) M1_SDamon=Dn;
        else if ( STOC_strength == -2 ) M1_SDamon=ArrowHeadDn;
        
    StrengthDamon( symbol, PERIOD_M5  ) ; 
        if ( MACD_strength == 0 )       M5_Damon=Flat;
        else if ( MACD_strength == 1 )  M5_Damon=Up;
        else if ( MACD_strength == 2 )  M5_Damon=ArrowHeadUp;
        else if ( MACD_strength == -1 ) M5_Damon=Dn;
        else if ( MACD_strength == -2 ) M5_Damon=ArrowHeadDn;
        
        if ( STOC_strength == 0 )       M5_SDamon=Flat;
        else if ( STOC_strength == 1 )  M5_SDamon=Up; 
        else if ( STOC_strength == 2 )  M5_SDamon=ArrowHeadUp;
        else if ( STOC_strength == -1 ) M5_SDamon=Dn;
        else if ( STOC_strength == -2 ) M5_SDamon=ArrowHeadDn;
          
    StrengthDamon( symbol, PERIOD_M15  )   ;
        if ( MACD_strength == 0 )       M15_Damon=Flat;
        else if ( MACD_strength == 1 )  M15_Damon=Up;
        else if ( MACD_strength == 2 )  M15_Damon=ArrowHeadUp;
        else if ( MACD_strength == -1 ) M15_Damon=Dn;
        else if ( MACD_strength == -2 ) M15_Damon=ArrowHeadDn;
        
        if ( STOC_strength == 0 )       M15_SDamon=Flat;
        else if ( STOC_strength == 1 )  M15_SDamon=Up; 
        else if ( STOC_strength == 2 )  M15_SDamon=ArrowHeadUp;
        else if ( STOC_strength == -1 ) M15_SDamon=Dn;
        else if ( STOC_strength == -2 ) M15_SDamon=ArrowHeadDn;
        
    StrengthDamon( symbol, PERIOD_M30  )  ;
        if ( MACD_strength == 0 )       M30_Damon=Flat;
        else if ( MACD_strength == 1 )  M30_Damon=Up;
        else if ( MACD_strength == 2 )  M30_Damon=ArrowHeadUp;
        else if ( MACD_strength == -1 ) M30_Damon=Dn;
        else if ( MACD_strength == -2 ) M30_Damon=ArrowHeadDn;
        
        if ( STOC_strength == 0 )       M30_SDamon=Flat;
        else if ( STOC_strength == 1 )  M30_SDamon=Up; 
        else if ( STOC_strength == 2 )  M30_SDamon=ArrowHeadUp;
        else if ( STOC_strength == -1 ) M30_SDamon=Dn;
        else if ( STOC_strength == -2 ) M30_SDamon=ArrowHeadDn;
        
    StrengthDamon( symbol, PERIOD_H1  )  ;
        if ( MACD_strength == 0 )       H1_Damon=Flat;
        else if ( MACD_strength == 1 )  H1_Damon=Up;
        else if ( MACD_strength == 2 )  H1_Damon=ArrowHeadUp;
        else if ( MACD_strength == -1 ) H1_Damon=Dn;
        else if ( MACD_strength == -2 ) H1_Damon=ArrowHeadDn;
        
        if ( STOC_strength == 0 )       H1_SDamon=Flat;
        else if ( STOC_strength == 1 )  H1_SDamon=Up; 
        else if ( STOC_strength == 2 )  H1_SDamon=ArrowHeadUp;
        else if ( STOC_strength == -1 ) H1_SDamon=Dn;
        else if ( STOC_strength == -2 ) H1_SDamon=ArrowHeadDn;
        
    StrengthDamon( symbol, PERIOD_H4  ) ;
        if ( MACD_strength == 0 )       H4_Damon=Flat;
        else if ( MACD_strength == 1 )  H4_Damon=Up;
        else if ( MACD_strength == 2 )  H4_Damon=ArrowHeadUp;
        else if ( MACD_strength == -1 ) H4_Damon=Dn;
        else if ( MACD_strength == -2 ) H4_Damon=ArrowHeadDn;
        
        if ( STOC_strength == 0 )       H4_SDamon=Flat;
        else if ( STOC_strength == 1 )  H4_SDamon=Up; 
        else if ( STOC_strength == 2 )  H4_SDamon=ArrowHeadUp;
        else if ( STOC_strength == -1 ) H4_SDamon=Dn;
        else if ( STOC_strength == -2 ) H4_SDamon=ArrowHeadDn;
        
    StrengthDamon( symbol, PERIOD_D1  ) ;
        if ( MACD_strength == 0 )       D1_Damon=Flat;
        else if ( MACD_strength == 1 )  D1_Damon=Up;
        else if ( MACD_strength == 2 )  D1_Damon=ArrowHeadUp;
        else if ( MACD_strength == -1 ) D1_Damon=Dn;
        else if ( MACD_strength == -2 ) D1_Damon=ArrowHeadDn;
        
        if ( STOC_strength == 0 )       D1_SDamon=Flat;
        else if ( STOC_strength == 1 )  D1_SDamon=Up; 
        else if ( STOC_strength == 2 )  D1_SDamon=ArrowHeadUp;
        else if ( STOC_strength == -1 ) D1_SDamon=Dn;
        else if ( STOC_strength == -2 ) D1_SDamon=ArrowHeadDn;
        
    StrengthDamon( symbol, PERIOD_W1  ) ;
        if ( MACD_strength == 0 )       W1_Damon=Flat;
        else if ( MACD_strength == 1 )  W1_Damon=Up;
        else if ( MACD_strength == 2 )  W1_Damon=ArrowHeadUp;
        else if ( MACD_strength == -1 ) W1_Damon=Dn;
        else if ( MACD_strength == -2 ) W1_Damon=ArrowHeadDn;
        
        if ( STOC_strength == 0 )       W1_SDamon=Flat;
        else if ( STOC_strength == 1 )  W1_SDamon=Up; 
        else if ( STOC_strength == 2 )  W1_SDamon=ArrowHeadUp;
        else if ( STOC_strength == -1 ) W1_SDamon=Dn;
        else if ( STOC_strength == -2 ) W1_SDamon=ArrowHeadDn;
        
    StrengthDamon( symbol, PERIOD_MN1  ) ;
        if ( MACD_strength == 0 )       MN1_Damon=Flat;
        else if ( MACD_strength == 1 )  MN1_Damon=Up;
        else if ( MACD_strength == 2 )  MN1_Damon=ArrowHeadUp;
        else if ( MACD_strength == -1 ) MN1_Damon=Dn;
        else if ( MACD_strength == -2 ) MN1_Damon=ArrowHeadDn;
        
        if ( STOC_strength == 0 )       MN1_SDamon=Flat;
        else if ( STOC_strength == 1 )  MN1_SDamon=Up; 
        else if ( STOC_strength == 2 )  MN1_SDamon=ArrowHeadUp;
        else if ( STOC_strength == -1 ) MN1_SDamon=Dn;
        else if ( STOC_strength == -2 ) MN1_SDamon=ArrowHeadDn;
        
    
    color color_MACD = Yellow ;       
    color color_STOC = Yellow; 
         
    int bump = 0;
    color thecolor; 
    
    int Col00x = Col01x + 20 ;
    int Col00y = 20+Shift_UP_DN ;

    Col01y = 20+Shift_UP_DN ;

    Obj0002 = IndNameMAC+"SignalM1t"  ; 
    
    if ( ObjectFind(Obj0002)>=0 ) ObjectDelete(Obj0002);    
    ObjectCreate(Obj0002, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0002,IndNameMAC, 7, "Tahoma Narrow",  BarLabel_color);  
    ObjectSet(Obj0002, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0002, OBJPROP_XDISTANCE, Col00x);
    ObjectSet(Obj0002, OBJPROP_YDISTANCE, Col00y + bump);  // 50+Shift_UP_DN

    Obj0003 = IndNameMAC+"SignalM1"  ; 
    if ( ObjectFind(Obj0003)>=0 ) ObjectDelete(Obj0003);
    if ( M1_Damon == Up || M1_Damon== ArrowHeadUp ) thecolor=UpArrowColor; else thecolor=DnArrowColor;        
    ObjectCreate(Obj0003, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0003, M1_Damon, 15, "Wingdings",  thecolor);
    ObjectSet(Obj0003, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0003, OBJPROP_XDISTANCE, Col01x);
    if ( M1_Damon == ArrowHeadUp  ) bump = -5; else bump=0;
    ObjectSet(Obj0003, OBJPROP_YDISTANCE, Col01y + bump); 

    Obj0004 = IndNameMAC+"SignalM5"  ;
    if ( ObjectFind(Obj0004)>=0 ) ObjectDelete(Obj0004);
    if ( M5_Damon == Up || M5_Damon== ArrowHeadUp ) thecolor=UpArrowColor; else thecolor=DnArrowColor;        
    ObjectCreate(Obj0004, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0004, M5_Damon, 15, "Wingdings",  thecolor);
    ObjectSet(Obj0004, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0004, OBJPROP_XDISTANCE, Col02x);
    if ( M5_Damon == ArrowHeadUp  ) bump = -5; else bump=0;
    ObjectSet(Obj0004, OBJPROP_YDISTANCE, Col01y + bump); 
 
    Obj0005 = IndNameMAC+"SignalM15"  ; 
    if ( ObjectFind(Obj0005)>=0 ) ObjectDelete(Obj0005);
    if ( M15_Damon == Up || M15_Damon== ArrowHeadUp ) thecolor=UpArrowColor; else thecolor=DnArrowColor; 
    ObjectCreate(Obj0005, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0005, M15_Damon, 15, "Wingdings",  thecolor);
    ObjectSet(Obj0005, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0005, OBJPROP_XDISTANCE, Col03x);
    if ( M15_Damon == ArrowHeadUp  ) bump = -5; else bump=0;
    ObjectSet(Obj0005, OBJPROP_YDISTANCE, Col01y + bump); 
  
    Obj0006 = IndNameMAC+"SignalM30"  ;
    if ( ObjectFind(Obj0006)>=0 ) ObjectDelete(Obj0006);
    if ( M30_Damon == Up || M30_Damon== ArrowHeadUp ) thecolor=UpArrowColor; else thecolor=DnArrowColor;
    ObjectCreate(Obj0006, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0006, M30_Damon, 15, "Wingdings",  thecolor);
    ObjectSet(Obj0006, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0006, OBJPROP_XDISTANCE, Col04x);
    if ( M30_Damon == ArrowHeadUp  ) bump = -5; else bump=0;
    ObjectSet(Obj0006, OBJPROP_YDISTANCE, Col01y + bump); 

    Obj0007 = IndNameMAC+"SignalM60"  ;
    if ( ObjectFind(Obj0007)>=0 ) ObjectDelete(Obj0007);
    if ( H1_Damon == Up || H1_Damon== ArrowHeadUp ) thecolor=UpArrowColor; else thecolor=DnArrowColor;    
    ObjectCreate(Obj0007, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0007, H1_Damon, 15, "Wingdings",  thecolor);
    ObjectSet(Obj0007, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0007, OBJPROP_XDISTANCE, Col05x);
    if ( H1_Damon == ArrowHeadUp  ) bump = -5; else bump=0;
    ObjectSet(Obj0007, OBJPROP_YDISTANCE, Col01y + bump); 

    Obj0008 = IndNameMAC+"SignalM240"  ;
    if ( ObjectFind(Obj0008)>=0 ) ObjectDelete(Obj0008);
    if ( H4_Damon == Up || H4_Damon== ArrowHeadUp ) thecolor=UpArrowColor; else thecolor=DnArrowColor;      
    ObjectCreate(Obj0008, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0008, H4_Damon, 15, "Wingdings",  thecolor);
    ObjectSet(Obj0008, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0008, OBJPROP_XDISTANCE, Col06x);
    if ( H4_Damon == ArrowHeadUp  ) bump = -5; else bump=0;
    ObjectSet(Obj0008, OBJPROP_YDISTANCE, Col01y + bump);

    Obj0009 = IndNameMAC+"SignalM1440"  ;
    if ( ObjectFind(Obj0009)>=0 ) ObjectDelete(Obj0009);
    if ( D1_Damon == Up || D1_Damon== ArrowHeadUp ) thecolor=UpArrowColor; else thecolor=DnArrowColor;
    ObjectCreate(Obj0009, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0009, D1_Damon, 15, "Wingdings",  thecolor);
    ObjectSet(Obj0009, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0009, OBJPROP_XDISTANCE, Col07x);
    if ( D1_Damon == ArrowHeadUp  ) bump = -5; else bump=0;
    ObjectSet(Obj0009, OBJPROP_YDISTANCE, Col01y + bump);

    Obj0010 = IndNameMAC+"SignalW1"  ;
    if ( ObjectFind(Obj0010)>=0 ) ObjectDelete(Obj0010);
    if ( W1_Damon == Up || W1_Damon== ArrowHeadUp ) thecolor=UpArrowColor; else thecolor=DnArrowColor;    
    ObjectCreate(Obj0010, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0010, W1_Damon, 15, "Wingdings",  thecolor);
    ObjectSet(Obj0010, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0010, OBJPROP_XDISTANCE, Col08x);
    if ( W1_Damon == ArrowHeadUp  ) bump = -5; else bump=0;
    ObjectSet(Obj0010, OBJPROP_YDISTANCE, Col01y + bump);   

    Obj0011 = IndNameMAC+"SignalMN1"  ;
    if ( ObjectFind(Obj0011)>=0 ) ObjectDelete(Obj0011);
    if ( MN1_Damon == Up || MN1_Damon== ArrowHeadUp ) thecolor=UpArrowColor; else thecolor=DnArrowColor;    
    ObjectCreate(Obj0011, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0011, MN1_Damon, 15, "Wingdings",  thecolor);
    ObjectSet(Obj0011, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0011, OBJPROP_XDISTANCE, Col09x);
    if ( MN1_Damon == ArrowHeadUp  ) bump = -5; else bump=0;
    ObjectSet(Obj0011, OBJPROP_YDISTANCE, Col01y + bump); 
 
 
// STOCHASTIC *****************************************************************************
 
    Col00x = Col01x + 20 ;
    Col00y = 50+Shift_UP_DN ;

    Col01y = 50+Shift_UP_DN ;

    Obj0002S = IndNameSTO+"SignalM1t"  ;
    if ( ObjectFind(Obj0002S)>=0 ) ObjectDelete(Obj0002S);  
    ObjectCreate(Obj0002S, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0002S,IndNameSTO, 7, "Tahoma Narrow",  BarLabel_color);  
    ObjectSet(Obj0002S, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0002S, OBJPROP_XDISTANCE, Col00x);
    ObjectSet(Obj0002S, OBJPROP_YDISTANCE, Col00y + bump);  // 50+Shift_UP_DN

    Obj0003S = IndNameSTO+"SignalM1"  ;
    if ( ObjectFind(Obj0003S)>=0 ) ObjectDelete(Obj0003S);
    if ( M1_SDamon == Up || M1_SDamon== ArrowHeadUp ) thecolor=UpArrowColor; else thecolor=DnArrowColor;        
    ObjectCreate(Obj0003S, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0003S, M1_SDamon, 15, "Wingdings",  thecolor);
    ObjectSet(Obj0003S, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0003S, OBJPROP_XDISTANCE, Col01x);
    if ( M1_SDamon == ArrowHeadUp  ) bump = -5; else bump=0;
    ObjectSet(Obj0003S, OBJPROP_YDISTANCE, Col01y + bump); 

    Obj0004S = IndNameSTO+"SignalM5"  ;
    if ( ObjectFind(Obj0004S)>=0 ) ObjectDelete(Obj0004S);
    if ( M5_SDamon == Up || M5_SDamon== ArrowHeadUp ) thecolor=UpArrowColor; else thecolor=DnArrowColor;         
    ObjectCreate(Obj0004S, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0004S, M5_SDamon, 15, "Wingdings",  thecolor);
    ObjectSet(Obj0004S, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0004S, OBJPROP_XDISTANCE, Col02x);
    if ( M5_SDamon == ArrowHeadUp  ) bump = -5; else bump=0;
    ObjectSet(Obj0004S, OBJPROP_YDISTANCE, Col01y + bump); 
  
    Obj0005S = IndNameSTO+"SignalM15"  ; 
    if ( ObjectFind(Obj0005S)>=0 ) ObjectDelete(Obj0005S);
    if ( M15_SDamon == Up || M15_SDamon== ArrowHeadUp ) thecolor=UpArrowColor; else thecolor=DnArrowColor;
    ObjectCreate(Obj0005S, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0005S, M15_SDamon, 15, "Wingdings",  thecolor);
    ObjectSet(Obj0005S, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0005S, OBJPROP_XDISTANCE, Col03x);
    if ( M15_SDamon == ArrowHeadUp  ) bump = -5; else bump=0;
    ObjectSet(Obj0005S, OBJPROP_YDISTANCE, Col01y + bump); 

    Obj0006S = IndNameSTO+"SignalM30"  ; 
    if ( ObjectFind(Obj0006S)>=0 ) ObjectDelete(Obj0006S);
    if ( M30_SDamon == Up || M30_SDamon== ArrowHeadUp ) thecolor=UpArrowColor; else thecolor=DnArrowColor;
    ObjectCreate(Obj0006S, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0006S, M30_SDamon, 15, "Wingdings",  thecolor);
    ObjectSet(Obj0006S, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0006S, OBJPROP_XDISTANCE, Col04x);
    if ( M30_SDamon == ArrowHeadUp  ) bump = -5; else bump=0;
    ObjectSet(Obj0006S, OBJPROP_YDISTANCE, Col01y + bump); 

    Obj0007S = IndNameSTO+"SignalM60"  ;
    if ( ObjectFind(Obj0007S)>=0 ) ObjectDelete(Obj0007S);
    if ( H1_SDamon == Up || H1_SDamon== ArrowHeadUp ) thecolor=UpArrowColor; else thecolor=DnArrowColor;      
    ObjectCreate(Obj0007S, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0007S, H1_SDamon, 15, "Wingdings",  thecolor);
    ObjectSet(Obj0007S, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0007S, OBJPROP_XDISTANCE, Col05x);
    if ( H1_SDamon == ArrowHeadUp  ) bump = -5; else bump=0;
    ObjectSet(Obj0007S, OBJPROP_YDISTANCE, Col01y + bump); 

    Obj0008S = IndNameSTO+"SignalM240"  ; 
    if ( ObjectFind(Obj0008S)>=0 ) ObjectDelete(Obj0008S);
    if ( H4_SDamon == Up || H4_SDamon== ArrowHeadUp ) thecolor=UpArrowColor; else thecolor=DnArrowColor;         
    ObjectCreate(Obj0008S, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0008S, H4_SDamon, 15, "Wingdings",  thecolor);
    ObjectSet(Obj0008S, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0008S, OBJPROP_XDISTANCE, Col06x);
    if ( H4_SDamon == ArrowHeadUp  ) bump = -5; else bump=0;
    ObjectSet(Obj0008S, OBJPROP_YDISTANCE, Col01y + bump);

    Obj0009S = IndNameSTO+"SignalM1440"  ; 
    if ( ObjectFind(Obj0009S)>=0 ) ObjectDelete(Obj0009S);
    if ( D1_SDamon == Up || D1_SDamon== ArrowHeadUp ) thecolor=UpArrowColor; else thecolor=DnArrowColor;   
    ObjectCreate(Obj0009S, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0009S, D1_SDamon, 15, "Wingdings",  thecolor);
    ObjectSet(Obj0009S, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0009S, OBJPROP_XDISTANCE, Col07x);
    if ( D1_SDamon == ArrowHeadUp  ) bump = -5; else bump=0;
    ObjectSet(Obj0009S, OBJPROP_YDISTANCE, Col01y + bump);

    Obj0010S = IndNameSTO+"SignalW1"  ;
    if ( ObjectFind(Obj0010S)>=0 ) ObjectDelete(Obj0010S);
    if ( W1_SDamon == Up || W1_SDamon== ArrowHeadUp ) thecolor=UpArrowColor; else thecolor=DnArrowColor;    
    ObjectCreate(Obj0010S, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0010S, W1_SDamon, 15, "Wingdings",  thecolor);
    ObjectSet(Obj0010S, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0010S, OBJPROP_XDISTANCE, Col08x);
    if ( W1_SDamon == ArrowHeadUp  ) bump = -5; else bump=0;
    ObjectSet(Obj0010S, OBJPROP_YDISTANCE, Col01y + bump);   

    Obj0011S = IndNameSTO+"SignalMN1"  ;
    if ( ObjectFind(Obj0011S)>=0 ) ObjectDelete(Obj0011S);
    if ( MN1_SDamon == Up || MN1_SDamon== ArrowHeadUp ) thecolor=UpArrowColor; else thecolor=DnArrowColor;    
    ObjectCreate(Obj0011S, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Obj0011S, MN1_SDamon, 15, "Wingdings",  thecolor);
    ObjectSet(Obj0011S, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
    ObjectSet(Obj0011S, OBJPROP_XDISTANCE, Col09x);
    if ( MN1_SDamon == ArrowHeadUp  ) bump = -5; else bump=0;
    ObjectSet(Obj0011S, OBJPROP_YDISTANCE, Col01y + bump); 
 
 
    return(0);
}


int deinit()
{

    deleteObject(); 
    ObjectsDeleteAll(0,OBJ_HLINE);
    ObjectsDeleteAll(0,OBJ_TEXT);
    ObjectsDeleteAll(0,OBJ_LABEL);

    return(0);
}
  
void deleteObject()
{ 

    //ObjectDelete(Obj0001);  
    ObjectDelete(Obj0002); 
    ObjectDelete(Obj0003); 
    ObjectDelete(Obj0004); 
    ObjectDelete(Obj0005); 
    ObjectDelete(Obj0006); 
    ObjectDelete(Obj0007); 
    ObjectDelete(Obj0008); 
    ObjectDelete(Obj0009); 
    ObjectDelete(Obj0010); 
    ObjectDelete(Obj0011); 

    ObjectDelete(Obj0002S); 
    ObjectDelete(Obj0003S); 
    ObjectDelete(Obj0004S); 
    ObjectDelete(Obj0005S); 
    ObjectDelete(Obj0006S); 
    ObjectDelete(Obj0007S); 
    ObjectDelete(Obj0008S); 
    ObjectDelete(Obj0009S); 
    ObjectDelete(Obj0010S); 
    ObjectDelete(Obj0011S); 


    ObjectDelete(ObjHead01);  
    ObjectDelete(ObjHead02); 
    ObjectDelete(ObjHead03); 
    ObjectDelete(ObjHead04); 
    ObjectDelete(ObjHead05); 
    ObjectDelete(ObjHead06); 
    ObjectDelete(ObjHead07); 
    ObjectDelete(ObjHead08); 
    ObjectDelete(ObjHead09); 
 
}


color StrengthDamon( string symbol, int period )  
{

         // add stochastic 

    double    Sto_m0 = iStochastic( 	symbol, period, K, D, Slow,MODE_SMA, 0, MODE_MAIN, 0);
    double    Sto_s0 = iStochastic( 	symbol, period, K, D, Slow,MODE_SMA, 0, MODE_SIGNAL, 0);
    
    double    Sto_m1 = iStochastic( 	symbol, period, K, D, Slow,MODE_SMA, 0, MODE_MAIN, 1);
    double    Sto_s1 = iStochastic( 	symbol, period, K, D, Slow,MODE_SMA, 0, MODE_SIGNAL, 1);
    
    double    Sto_m2 = iStochastic( 	symbol, period, K, D, Slow,MODE_SMA, 0, MODE_MAIN, 2);
    double    Sto_s2 = iStochastic( 	symbol, period, K, D, Slow,MODE_SMA, 0, MODE_SIGNAL, 2);
    
    if ( Sto_m0 >= Level4 ) lastExtreme = 1; 
    else if ( Sto_m0 <= Level2 ) lastExtreme = -1;
    
    // Stoc logic 
    STOC_strength =0;
    
    if(   MathAbs(Sto_m0-Sto_s0) < 0 ) STOC_strength = 0;
    else
    { 
        if ( Sto_m0 < Sto_s0 )  STOC_strength = -1;   // SELL
        if (  Sto_m2 < Level4                                                   // three Main bars below 80
                && Sto_m0 < Sto_s0 && Sto_m1 < Sto_s1 && Sto_m2 < Sto_s2    // all mains less than signal
                && Sto_m0 < Sto_m1 && Sto_m1 < Sto_m2                       // all mains are falling 
                )                                       // coming down from strong high 
            STOC_strength = -2;                                   
    
     
        else if (  Sto_m0 > Sto_s0 ) STOC_strength = 1;   //  BUY
        else if (   Sto_m2 > Level2                                            // three Main bars above 25 
                && Sto_m0 > Sto_s0 && Sto_m1 > Sto_s1 && Sto_m2 > Sto_s2  // all mains above signal
                && Sto_m0 < Sto_m1 && Sto_m1 < Sto_m2                     // all mains are rising 
                 )                                   // rising up from deep low 
            STOC_strength = 2; 
    }


     // Macd logic 

    double    Macd0  = iMACD(symbol,period,FastEMA,SlowEMA,SignalSMA,AppliedPrice,MODE_MAIN,0);
    double    Macd1  = iMACD(symbol,period,FastEMA,SlowEMA,SignalSMA,AppliedPrice,MODE_MAIN,1);
    double    Macd2  = iMACD(symbol,period,FastEMA,SlowEMA,SignalSMA,AppliedPrice,MODE_MAIN,2);
  //  double    Macd3  = iMACD(symbol,period,FastEMA,SlowEMA,SignalSMA,AppliedPrice,MODE_MAIN,3);

    double    MacdSignal0 = iMACD(symbol,period,FastEMA,SlowEMA,SignalSMA,AppliedPrice,MODE_SIGNAL,0);
    double    MacdSignal1 = iMACD(symbol,period,FastEMA,SlowEMA,SignalSMA,AppliedPrice,MODE_SIGNAL,1);
    double    MacdSignal2 = iMACD(symbol,period,FastEMA,SlowEMA,SignalSMA,AppliedPrice,MODE_SIGNAL,2);
 //   double    MacdSignal3 = iMACD(symbol,period,FastEMA,SlowEMA,SignalSMA,AppliedPrice,MODE_SIGNAL,3);




// change short logic to:
//    if main2 is below signal 
//    and all mains are falling
//    and main is above 50  Then strong sell 
//  MACD_strength, STOC_strength 

    if ( Macd0 == 0.0 || MacdSignal0 == 0.0 ) Alert("Got zeros for MACD ");
    
    MACD_strength = 0; 
     
    if ( Macd0 < MacdSignal0 )      MACD_strength = -1;
    if ( Macd0 > MacdSignal0 )      MACD_strength = 1;
    
    if (        Macd2 < MacdSignal2 && Macd0 < MacdSignal0  // all mains are below signals
            &&  Macd0 < Macd1 && Macd1 < Macd2              // all mains are falling
            &&  Macd0 > 0.0 )                                // main is in top half of display
        MACD_strength = -2 ;
 
    
    if (        Macd2 > MacdSignal2 && Macd0 > MacdSignal0  // all mains are above signals
            &&  Macd0 > Macd1 && Macd1 > Macd2              // all mains are rising
            &&  Macd0 < 0.0 )                                // main is in bottom half of display
        MACD_strength = 2 ; 
 
        
          
 /*          // if macd main has been below zero in last 3 bars , add up macdBelow0 from 1 to 3
    if( Macd0 < 0 ) { macdBelow0 = 1 ; } 
    if( Macd1 < 0 ) { macdBelow0 = macdBelow0 + 1 ; }     
    if( Macd2 < 0 ) { macdBelow0 = macdBelow0 + 1 ; }   
                    
           // if macd is 1 to 3 bars above zero, add up macdAbove0 from 1 to 3
    if( Macd0 > 0 ) { macdAbove0 = 1 ; } 
    if( Macd1 > 0 ) { macdAbove0 = macdAbove0 + 1 ; }     
    if( Macd2 > 0 ) { macdAbove0 = macdAbove0 + 1 ; }   


    short1 = ( Macd3 > MacdSignal3 &&  Macd2 < MacdSignal2                // main crossed sig three bars ago 
                && Macd1 < MacdSignal1 && Macd0 <= MacdSignal0            //   and all later mains are less than signal
                && Macd0 <= Macd1 && Macd1 <= Macd2  &&  Macd2 <= Macd3   // all mains are falling      
                && macdBelow0 >= 1  ) ;                                      // was <=, demanded one and only one bar has been below zero
                                                                          // changed to demand at least one is below zero
    long1  = ( Macd3 < MacdSignal3 &&  
               Macd2 >= MacdSignal2 && Macd2 >= Macd3 &&   
               Macd1 >= MacdSignal1 && Macd1 >= Macd2 &&            
               Macd0 >= MacdSignal0 && Macd0 >= Macd1 && 
               macdAbove0 >= 1   ) ;   // was <=

    short2 = ( Macd1 > 0 &&  Macd0 < 0 &&  Macd0 <= MacdSignal0  ) ;   
    long2 =  ( Macd1 < 0 &&  Macd0 > 0 &&  Macd0 >= MacdSignal0  ) ;   

    short3 = ( Macd2 < 0 && Macd2 <= MacdSignal2 && 
               Macd1 < 0 && Macd1 >  MacdSignal1 &&    
               Macd0 < 0 && Macd0 <= MacdSignal0   ) ;

    long3  = ( Macd2 > 0 && Macd2 >= MacdSignal2 && 
               Macd1 > 0 && Macd1 <  MacdSignal1 &&    
               Macd0 > 0 && Macd0 >= MacdSignal0     ) ;

    
   
    while(true)
    {
        if( short1 ) { MA_strength = Sell1_color  ; break ; }
        if( short2 ) { MA_strength = Sell2_color  ; break ; }
        if( short3 ) { MA_strength = Sell3_color  ; break ; }  
        if( long1 )  { MA_strength = Buy1_color  ; break ; }
        if( long2 )  { MA_strength = Buy2_color  ; break ; } 
        if( long3 )  { MA_strength = Buy3_color  ; break ; } 
                   
        MA_color = Wait_color ; break;
    } 
*/

    return( 0 ) ;   
                                    
} 

/*

Comment(

"LR.price.1= ", DoubleToStr(LR.price.1 , Digits), "\n", 
"LR.price.2= ", DoubleToStr(LR.price.2 , Digits), "\n", 

"") ;

Here are the 3 different Entry Signals that the Indicator should generate.

 these comments by the original author (Damon ? ) 

   1. The three bar pull back

         1. Short Trade

            i.  This is when MACD value has been > MACD signal and then MACD value closes = or < MACD signal 
                for 3 consecutive bars with each having an equal to or lower and lower value. 
                If one of the 3 bars has a higher value, then this would null and void any signal.  
                If the value remains = to the previous bar, all bets are on. 
                Only if the value gets greater are all bets off.

            ii. After 3 consecutive lower or equal values than each previous bar, 
                a short symbol can be generated at the bar that has the lowest low of the 3.

            iii. The value must not have gone below the 0 level by more than 1 bar

            iv.  If a trade is cancelled because MACD bar values go higher, 
                this short trade will not be reconsidered until once again, the value 
                becomes > the signal, and then back to less then the signal 
                for 3 consecutive lower or equal value bars.

         2. Long Trade

              i. This is of course opposite of the short trade. If you need a description, please let me know.

   2. The 0 (zero) cross.
         1. Short trade

             i. When the MACD goes from positive value to negative value and 
                 is < the signal value, a short signal can be generated.

         2. Long Trade

             i. Opposite of a short trade. Please let me know if you need a description of this.

   3. The Continuation Trade
         1. Short Trade

             i. This happens when the value is negative (below zero level) and < the signal 
             value and then the value stays negative, but becomes > or = the signal value. Once 
             this happens we wait for the value to once again become < the signal value. When this happens, 
             a short symbol can be generated on the screen.

             ii. However.if at the time the value becomes < the signal value again, the trade
                 will not be considered if the value is < or = to level x.

         2. Long Trade

             i. Opposite of a short trade. Please let me know if you need a description

 

Here is how I would like to generate Exit Signals using the two (2) exit indicators as described above

 

   1. MACD as an exit signal.
         1. Short Trade

              i.      Basically the MACD would give us an exit signal if we were in a short trade 
              when the value of the most recent closed bar became > the value of the bar that closed before it.

         2. Long Trade

               i.      This is of course opposite of a Short Trade. Please let me know if you need a description of this.

   2. OsMA_MACD as an exit signal as an option
         1. Short Trade

                i.      Basically if we are in a short trade, and the 
                OsMA_MACD closes x bars in Lime, we would get an exit signal.

         2. Long Trade

                i.      Opposite of a short trade. If you need a description of this please let me know.

 
 
*/